% Kugler (603399)
% Aufgabenblatt 5

:- use_module(library(lists)).

% -------------------------------------
%        Aufgabe 1
% -------------------------------------
alle_variablen(Term, []):-
    atomic(Term).

alle_variablen(Term, [Term]):-
    var(Term).

alle_variablen(Term, Liste):-
    compound(Term),
    functor(Term, _, N),
    alle_variablen(N, Term, Liste).

alle_variablen(0, _, []).

alle_variablen(N, Term, Liste):-
    N > 0,
    arg(N, Term, Arg),
    alle_variablen(Arg, NeueListe),
    N1 is N - 1,
    alle_variablen(N1, Term, DavorListe),
    append(NeueListe,DavorListe,Liste).

% -------------------------------------
%        Aufgabe 2
% -------------------------------------
reverse_list([X|Y],Z,W) :- reverse_list(Y,[X|Z],W).
reverse_list([],X,X).

strukturbild(X,+):-
	atomic(X).

strukturbild(X,-):-
	var(X).
	
strukturbild(X, Liste):-
	compound(X),
	functor(X,_,N),
	durchsuche_liste(N,X,ListeFalschrum),
	reverse_list(ListeFalschrum,[],Liste).

durchsuche_liste(0,_,[]).

durchsuche_liste(N,Term,[Liste1|Liste2]):-
	N > 0,
	arg(N,Term,Arg),
	strukturbild(Arg,Liste1),
	N1 is N-1,
	durchsuche_liste(N1,Term,Liste2).

% -------------------------------------
%        Aufgabe 3
% -------------------------------------
position(_,X,[]):-
	atomic(X). 
	
position(S,T,P):-
	compound(T),
	functor(T,_,N),
	position(N,S,T,P).

position(N,S,T,[N|X]):-
	arg(N,T,Arg),
	position(S,Arg,X).

position(N,S,T,X):-
	N>1,
	N1 is N-1,
	position(N1,S,T,X).