% Kugler (603399)
% -------------------------

:- use_module(library(lists)).
:- dynamic vorkommen/2.

% -------------------------
% Aufgabe 4
% -------------------------

kodiere_datei(In,Out):-
    see(In),
    tell(Out),
    verarbeite,
    told,
    seen.

verarbeite:-
    read_line(X),
    verarbeite_line(X).

verarbeite_line(end_of_file):-
    !.

verarbeite_line(X):-
    veraendere(X,Y),
    name(Z,Y),
    write(Z), nl,
    verarbeite.

veraendere([],[]).

veraendere([X|Xs],[Y|Ys]):-
    Y is X + 13,
    veraendere(Xs,Ys).

% -------------------------
% Aufgabe 1
% -------------------------

weiterlesen(end_of_file):- !.
weiterlesen(Term):-
    functor(Term,:-,_),
    arg(1,Term,P),
    functor(P,X,N),
    print(X), 
    tab(4),
    print(N),
    nl,
    lies_datei.

lies_datei:-
    read(Term),
    weiterlesen(Term).

protokoll(Infile,Outfile):-
    see(Infile),
    tell(Outfile),
    lies_datei,
    seen,
    told.

% -------------------------
% Aufgabe 2
% -------------------------

print_list(X):-
    print('['),
    nl,    
    print_tab(X,1),
    print(']'),
    nl.
print_tab([],_):- !.

print_tab([[X|Xs]|Zs],N):-
    M is N + 1,
    tab(N),
    print('['),
    nl,    
    print_tab([X|Xs],M),
    tab(N),
    print(']'),
    nl,
    print_tab(Zs,N). 

print_tab([X|Xs],N):-
    atom(X),
    tab(N),
    print(X),
    nl,
    print_tab(Xs,N).

% -------------------------
% Aufgabe 3
% -------------------------

in_basis(X):-
	retract(vorkommen(X,Y)),
	F is Y + 1,
	assertz(vorkommen(X,F)),!.
in_basis(X):-
	assertz(vorkommen(X,1)).

in_die_basis([]):- !.
in_die_basis([X|Xs]):-
	retract(vorkommen(X,Y)),
	F is Y + 1,
    assertz(vorkommen(X,F)),
    in_die_basis(Xs),!.
in_die_basis([X|Xs]):-
    assertz(vorkommen(X,1)),
    in_die_basis(Xs).

aus_der_basis:-
	retract(vorkommen(X,Y)),!,
	write(vorkommen(X,Y)),
	nl,
	aus_der_basis.

vokabular(Infile,Outfile):-
    see(Infile),
    tell(Outfile),
    read_sentence(_),
    seen,
    told.

% abgewandelte version von read_sentence aus dem script
read_sentence(Words) :-
    get0(FirstChar),
    read_words(FirstChar, Words).

read_words(Char, [Word|Words]) :-
    word_char(Char),
    read_word(Char, Word, NextChar),
    read_words(NextChar, Words).

read_words(Char, Words) :-
    fill_char(Char), 
    get0(NextChar),
    read_words(NextChar, Words).

read_words(Char, []) :-
	aus_der_basis.

read_word(Char, Word, NextChar) :-
    word_chars(Char, Chars, NextChar),
    name(Word, Chars),
    in_basis(Word).

word_chars(Char, [Char|Chars], FinalChar) :-
    word_char(Char), !, 
    get0(NextChar), 
    word_chars(NextChar, Chars, FinalChar).

word_chars(Char, [ ], Char) :-
    not(word_char(Char)). 

word_char(C) :-
	97 =< C,
	C =< 122.

word_char(C) :-
	65 =< C,
	C =< 90. 

word_char(95). 

fill_char(32).
fill_char(10).